//   GAMBIT: Global and Modular BSM Inference Tool
//   *********************************************
///  \file
///
///  Rollcall header for model @MODEL@ in
///  ColliderBit.
///
///  Automatically generated by GUM.
///
///  \author The GAMBIT Collaboration
///          http://gambit.hepforge.org
///  \date @DATETIME@
///
///  *********************************************

#pragma once

#define MODULE ColliderBit


  // Construct an SLHAea object with spectrum and decays for Pythia
  #define CAPABILITY SpectrumAndDecaysForPythia

    #define FUNCTION getSpectrumAndDecaysForPythia_@MODEL@
    START_FUNCTION(SLHAstruct)
    DEPENDENCY(decay_rates, DecayTable)
    DEPENDENCY(@MODEL@_spectrum, Spectrum)
    ALLOW_MODEL(@MODEL@)
    #undef FUNCTION

  #undef CAPABILITY


  // Get Monte Carlo event generator
  #define CAPABILITY HardScatteringSim

    #define FUNCTION getPythia_@MODEL@
    START_FUNCTION(Py8Collider_@MODEL@_defaultversion)
    NEEDS_MANAGER(RunMC, MCLoopInfo)
    NEEDS_CLASSES_FROM(Pythia_@MODEL@, default)
    ALLOW_MODEL(@MODEL@)
    DEPENDENCY(SpectrumAndDecaysForPythia, SLHAstruct)
    #undef FUNCTION

    #define FUNCTION getPythia_@MODEL@AsBase
    START_FUNCTION(const BaseCollider*)
    NEEDS_MANAGER(RunMC, MCLoopInfo)
    NEEDS_CLASSES_FROM(Pythia_@MODEL@, default)
    DEPENDENCY(HardScatteringSim, Py8Collider_@MODEL@_defaultversion)
    ALLOW_MODEL(@MODEL@)
    #undef FUNCTION

  #undef CAPABILITY


  // Run event generator
  #define CAPABILITY HardScatteringEvent
    #define FUNCTION generateEventPythia_@MODEL@
    START_FUNCTION(HEPUtils::Event)
    NEEDS_MANAGER(RunMC, MCLoopInfo)
    NEEDS_CLASSES_FROM(Pythia_@MODEL@, default)
    DEPENDENCY(HardScatteringSim, Py8Collider_@MODEL@_defaultversion)
    DEPENDENCY(EventWeighterFunction, EventWeighterFunctionType)
    ALLOW_MODEL(@MODEL@)
    #undef FUNCTION
  #undef CAPABILITY


#undef MODULE
